package cz.muni.fi.pb138.demo.xincludejaxp;

import java.io.IOException;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import javax.xml.transform.Result;
import javax.xml.transform.Source;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.w3c.dom.Document;
import org.xml.sax.SAXException;

/*
 * Created on 20.2.2006
 *
 */

/**
 * @author Jan Pavlovic
 * @author tomp
 *
 */
public class Demo {
    
    public static void main(String[] args) throws TransformerException, 
            ParserConfigurationException, IOException, SAXException {
        
        if (args.length == 2) {
            transformFileToFile(args[0], args[1]);
        } else {
            System.out.println("Invalid arguments provided. Use: java -classpath " +
                    "resolver.jar;classes cz.muni.fi.pb138.xincludejacxp.Demo " +
                    "<srcFile> <destFile>");
        }
    }
    
    public static void transformFileToFile(String srcFilename, String destFilename) 
        throws TransformerException, ParserConfigurationException, IOException, SAXException {
        
        DocumentBuilderFactory dbfactory = DocumentBuilderFactory.newInstance();
        
        dbfactory.setNamespaceAware(true);
        dbfactory.setXIncludeAware(true);
        
        DocumentBuilder domparser = dbfactory.newDocumentBuilder();
        Document doc = domparser.parse(srcFilename);
        
        //prepare the DOM source
        Source xmlsource = new DOMSource(doc);
        
        Result result = new StreamResult(destFilename);
   
        //create a transformer factory
        TransformerFactory xfactory = TransformerFactory.newInstance();
        
        //create a transformer
        Transformer xformer = xfactory.newTransformer();
        
        //transform to raise the SAX events from DOM
        xformer.transform(xmlsource, result);
                
        
    }
}
